---
title: List rows
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Reference Tables
---

# List rows{% #list-rows %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                                                    |
| ----------------- | ------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/reference-tables/tables/{id}/rows/list |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/reference-tables/tables/{id}/rows/list |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/reference-tables/tables/{id}/rows/list      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/reference-tables/tables/{id}/rows/list      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/reference-tables/tables/{id}/rows/list  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/reference-tables/tables/{id}/rows/list     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/reference-tables/tables/{id}/rows/list |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/reference-tables/tables/{id}/rows/list |

### Overview

List all rows in a reference table using cursor-based pagination. Pass the `page[continuation_token]` from the previous response to fetch the next page on the same consistent snapshot. Returns 400 for tables with more than 10,000,000 rows.

### Arguments

#### Path Parameters

| Name                 | Type   | Description                                                 |
| -------------------- | ------ | ----------------------------------------------------------- |
| id [*required*] | string | Unique identifier of the reference table to list rows from. |

#### Query Strings

| Name                     | Type    | Description                                                                                                                |
| ------------------------ | ------- | -------------------------------------------------------------------------------------------------------------------------- |
| page[limit]              | integer | Number of rows to return per page. Defaults to 100, maximum is 1000.                                                       |
| page[continuation_token] | string  | Opaque cursor from the previous response's next link. Pass this to retrieve the next page on the same consistent snapshot. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Paginated list of reference table rows.

| Parent field | Field                   | Type     | Description                                                                            |
| ------------ | ----------------------- | -------- | -------------------------------------------------------------------------------------- |
|              | data [*required*]  | [object] | The rows.                                                                              |
| data         | attributes              | object   | Column values for this row in the reference table.                                     |
| attributes   | values                  | object   | Key-value pairs representing the row data, where keys are field names from the schema. |
| data         | id                      | string   | Row identifier, corresponding to the primary key value.                                |
| data         | type [*required*]  | enum     | Row resource type. Allowed enum values: `row`                                          |
|              | links [*required*] | object   | Pagination links for the list rows response.                                           |
| links        | first [*required*] | string   | Link to the first page of results.                                                     |
| links        | next                    | string   | Link to the next page of results. Only present when more rows are available.           |
| links        | self [*required*]  | string   | Link to the current page of results.                                                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "values": {
          "category": "tor",
          "intention": "suspicious",
          "ip_address": "102.130.113.9"
        }
      },
      "id": "102.130.113.9",
      "type": "row"
    }
  ],
  "links": {
    "first": "/api/v2/reference-tables/tables/00000000-0000-0000-0000-000000000000/rows/list?page%5Blimit%5D=100",
    "self": "/api/v2/reference-tables/tables/00000000-0000-0000-0000-000000000000/rows/list?page%5Bcontinuation_token%5D=eyJzaWQiOjEyMzQ1LCJwayI6ImV4YW1wbGVfcGsifQ%3D%3D\u0026page%5Blimit%5D=100"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export id="00000000-0000-0000-0000-000000000000" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/reference-tables/tables/${id}/rows/list" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
{% /tab %}
